/*
 * T.C.F.S. 2.0 Alpha 1 
 *
 *      	   This  program  handles  RPC  "NFS"  data  requests
 *              adopting a secure transfer protocol.
 *                 This   is  an  unsecure   and  unchecked  version,
 *              use at your own risk.
 *
 *              Please, report Bugs to: <tcfs@edu-gw.dia.unisa.it>
 *
 * Authors:	Giuseppe Cattaneo, <cattaneo@udsab.dia.unisa.it>
 *		Giuseppe Persiano, <giuper@udsab.dia.unisa.it>
 *		Andrea Cozzolino, <andcoz@edu-gw.dia.unisa.it>
 *		Angelo Celentano, <angcel@edu-gw.dia.unisa.it>
 *		Aniello Del Sorbo, <anidel@edu-gw.dia.unisa.it>
 *		Ermelindo Mauriello, <ermmau@edu-gw.dia.unisa.it>
 *		Raffaele Pisapia, <rafpis@edu-gw.dia.unisa.it>
 *
 *   Permission to  use, copy, and modify  this software  without fee
 * is hereby granted, provided that this entire notice is included in
 * all copies  of  any  software  which  is  or  includes a  copy  or
 * modification of this software and in all copies  of the supporting
 * documentation for such software.
 *
 *   This  software is  distribuited  under  the  GNU General  Public
 * License  (version  2, June  1991). Check  the  file  'COPYING'  for
 * more  infos. Some  parts of  this  software  derive  from the  NFS
 * implementation in the Linux kernel 2.0.x.
 *
 * This software  maybe be used  for any  purpose provided  the above
 * copyright  notice  is retained.  It  is  supplied  as is,  with no
 * warranty expressed or implied.
 *
 */

/* -+-_== */

#include <linux/kdes.h>

#define DES8(a)		((int)((((int)(a) % 8)!=0)?(((int)(a) & 0xfffffff8)+8):(int)(a)))

void ides(char *buffer,int numblocks, des_key_schedule *ks,int mode);
void ikdes(char *buffer,int numblocks, des_key_schedule *ks,int mode);

/* Use these defines to crypt and decrypt */
#define endes(x,y,z) ides(x,y,z,DES_ENCRYPT)
#define dedes(x,y,z) ides(x,y,z,DES_DECRYPT)
/* These are for encryption in kernel memory */
#define kendes(x,y,z) ikdes(x,y,z,DES_ENCRYPT)
#define kdedes(x,y,z) ikdes(x,y,z,DES_DECRYPT)

void mkendes(char *,int,des_key_schedule *);
void mkdedes(char *,int,des_key_schedule *);
void mendes(char *,int,des_key_schedule *);
void mdedes(char *,int,des_key_schedule *);
